/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2014 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/

//***********************************************************************************************************
//  Nuvoton Technology Corp.
//  Date: 23/Jan/2014
//  E-Mail: MicroC-8bit@nuvoton.com
//***********************************************************************************************************

#include <stdio.h>
#include "N79E81x.h"
#include "Typedef.h"
#include "Define.h"
#include "Common.h"
#include "Delay.h"

//-----------------------------------------------------------------------------------------------------------
// Use timer1 as baud rate generator
void InitialUART0_Timer1(UINT32 u32Baudrate)
{
    SCON = 0x52;
    TMOD = 0x20;

#ifdef FOSC_110592
    TH1 = 256 - (28800/u32Baudrate); /* 11.059M/384=28800 */
#endif
#ifdef FOSC_184320
    TH1 = 256 - (48000/u32Baudrate); /* 18.4320M/384=48000 */
#endif
#ifdef FOSC_221184
     TH1 = 256 - (57600/u32Baudrate); /* 22.1184M/384=57600 */
#endif
#ifdef FOSC_331776
     TH1 = 256 - (86400/u32Baudrate); /* 33.1776M/384=86400 */
#endif
#ifdef FOSC_368640
     TH1 = 256 - (96000/u32Baudrate); /* 36.8640M/384=96000 */
#endif
    TR1 = 1;
}
//-----------------------------------------------------------------------------------------------------------
UINT8 Receive_Data_From_PC(void)
{
    UINT8 c;

    while (!RI);
    c = SBUF;
    RI = 0;
    return (c);
}
//-----------------------------------------------------------------------------------------------------------
void Send_Data_To_PC (UINT8 c)
{
    while (!TI);
    TI = 0;
    SBUF = c;
}
//-----------------------------------------------------------------------------------------------------------