#include "N79E81x.h"
#include "Typedef.h"
#include "Define.h"
#include "Common.h"
#include <stdio.h>


#define   PAGE_ERASE_DATA       0x22
#define   FLASH_READ_DATA       0x00
#define   BYTE_PROGRAM_DATA     0x21
#define   DATAFLASH_START_ADDR  0x3000


BIT EA_Save_bit;
//-----------------------------------------------------------------------------------------------------------
void Clear_BOF(void)
{
    EA_Save_bit = EA;
    EA = 0;
    TA = 0xAA;
    TA = 0x55;
    PMCR &= ~0x08;
    EA = EA_Save_bit;
}
//-----------------------------------------------------------------------------------------------------------
void Enable_BOD38_Det(void)
{
	/*ISPΧ3V~5Vʵѡ3.8V*/
    EA_Save_bit = EA;
    EA = 0;
    TA = 0xAA;
    TA = 0x55;
    PMCR = 0xC0;
    EA = EA_Save_bit;
}
//-----------------------------------------------------------------------------------------------------------
void Disable_BOD_Det(void)
{
    EA_Save_bit = EA;
    EA = 0;
    TA = 0xAA;
    TA = 0x55;
    PMCR = 0x00;
    EA = EA_Save_bit;
}
//-----------------------------------------------------------------------------------------------------------
void Enable_ISP_Mode(void)
{
    /* Enable ISP  */
    EA_Save_bit = EA;
    EA = 0;
    TA = 0xAA;
    TA = 0x55;
    CHPCON |= 0x01;
    EA = EA_Save_bit;
}
//-----------------------------------------------------------------------------------------------------------
void Disable_ISP_Mode(void)
{
    /* Disable ISP */
    EA_Save_bit = EA;
    EA = 0;
    TA = 0xAA;
    TA = 0x55;
    CHPCON &= 0xFE;
    EA = EA_Save_bit;
}
//-----------------------------------------------------------------------------------------------------------
void Trigger_ISP(void)
{
    EA_Save_bit = EA;
    EA = 0;
    TA = 0xAA;
    TA = 0x55;
    ISPTRG |= 0x01;
    EA = EA_Save_bit;
}
//-----------------------------------------------------------------------------------------------------------
void Erase_DataFlash(UINT16 u16DataAdr)
{
    Enable_ISP_Mode();
    ISPCN = PAGE_ERASE_DATA;
	ISPFD = 0xFF;
    ISPAL = LOBYTE(u16DataAdr);
    ISPAH = HIBYTE(u16DataAdr);
    Trigger_ISP();
    Disable_ISP_Mode();
}

//-----------------------------------------------------------------------------------------------------------

void Write_DataFlash(UINT16 u16DataAdr,UINT8 *pDat,UINT8 num) 
{
	/*עдֽҪ֤ͬһҳ(ÿҳ128ֽ)*/
	UINT8 i;
    Enable_ISP_Mode();
    ISPAL = LOBYTE(u16DataAdr);
    ISPAH = HIBYTE(u16DataAdr);
    ISPCN = BYTE_PROGRAM_DATA;
	for(i=0;i<num;i++)
    {
        ISPFD=pDat[i];
        Trigger_ISP();
        ISPAL++;
    }
    Disable_ISP_Mode();

}
//-----------------------------------------------------------------------------------------------------------
void Read_DataFlash(UINT16  u16DataAdr,UINT8 *pDat,UINT8 num) 
{
	UINT8 i;
    Enable_ISP_Mode();
    ISPAL = LOBYTE(u16DataAdr);
    ISPAH = HIBYTE(u16DataAdr);
    ISPCN = FLASH_READ_DATA;
    for(i=0;i<num;i++)
    {
		ISPFD=0;
        Trigger_ISP();
		pDat[i]=ISPFD;
        ISPAL++;
		if(ISPAL==0)ISPAH++;
    }
    Disable_ISP_Mode();

}
//-----------------------------------------------------------------------------------------------------------

UINT8 Sum;

void main(void)
{
	UINT8 code *pdataflash;
	InitialUART0_Timer1(9600);      // 9600 Baud Rate @ 11.0592MHz
	printf ("\n*  Name: N79E81x Series Sample Code.\n");
	pdataflash=DATAFLASH_START_ADDR;
	Sum=*pdataflash;		        //APROMпʹָ뷽ʽȡdataflash
	printf ("Sum:0x%bx\n",Sum);		//ӡsumֵÿζϵǰݻ1
									//ϵ籣ݳɹͻῴsumÿϵ綼1
	Enable_BOD38_Det();
	EBO   = 1;						//ʹBODж
    EA    = 1;                      //ʹȫж
	
	while(1);
    
}
//-----------------------------------------------------------------------------------------------------------
void BOD_ISR(void) interrupt 8           // Vector @  0x43
{
	UINT8 CheckData;
	/*BOD⵽VDDѹ˵3.8VʱBODж*/
	Disable_BOD_Det();//дdataflashǰһҪرBODд벻ɹ
	Sum=Sum+1;
    do
    {
	   Erase_DataFlash(DATAFLASH_START_ADDR);//дǰҪѴддݻ
	   Write_DataFlash(DATAFLASH_START_ADDR,&Sum,1);//дݵdataflashУֶֽ֧д룬
													//ֻд1ֽڹnumΪ1.
	   Read_DataFlash(DATAFLASH_START_ADDR,&CheckData,1); //У飬ȷдȷ
    }
    while(Sum!=CheckData);

}


